<?php

final class Alerts
{
    private static $instance;

    private array $alerts = [];

    private function __construct() {
    }

    private function __clone() {
    }

    public static function getInstance(): self {
        if (!isset(self::$instance)) {
            self::$instance = new self;
        }
        return self::$instance;
    }

    public function add(string $type, string $message): self {
        $this->alerts[$type] = $message;
        return $this;
    }

    public function get(string $type): string {
        return $this->alerts[$type] ?? '';
    }

    public function all(): array {
        return $this->alerts;
    }

}


