<?php
//Import PHPMailer classes into the global namespace
//These must be at the top of your script, not inside a function

require_once __DIR__ . '/PHPMailer/Exception.php';
//include_once __DIR__ . '/PHPMailer/OAuth.php';
//include_once __DIR__ . '/PHPMailer/OAuthTokenProvider.php';
require_once __DIR__ . '/PHPMailer/PHPMailer.php';
//include_once __DIR__ . '/PHPMailer/POP3.php';
require_once __DIR__ . '/PHPMailer/SMTP.php';

use PHPMailer\PHPMailer;
use PHPMailer\SMTP;
use PHPMailer\Exception;

class Email
{
    private PHPMailer $mail;
    private array $options;

    public function __construct(array $options)
    {
        //$options['user'] = 'noreply@workvee.com';
        $options['host'] = 'mboxhosting.com';
        $options['pass'] = 'baztU395SCfQekN';
        $options['port'] = '465';

        $this->options = $options;

        if ($this->validateOptions($options)) {
            $this->initSettings();
            $this->addRecipients();
            $this->addBody();
            $this->addAttachments();
        }
    }

    private function validateOptions(array $options): bool
    {
        if (!isset($options['host'])) {
            throw new Exception("Host is required.");
        } else if (!isset($options['port'])) {
            throw new Exception("Port is required.");
        } else if (!isset($options['user']) || !isset($options['pass'])) {
            throw new Exception("Authentication is invalid.");
        } else if (!isset($options['from'])) {
            throw new Exception("From is invalid.");
        } else if (!isset($options['recipients'])) {
            throw new Exception("Recipient is required.");
        } else if (!isset($options['subject'])) {
            throw new Exception("Subject is required.");
        } else if (!isset($options['body'])) {
            throw new Exception("Body is required.");
        }

        return true;
    }

    private function initSettings(): void
    {
        //Create an instance; passing `true` enables exceptions
        $this->mail = new PHPMailer(true);
        //Server settings
        $this->mail->SMTPDebug = SMTP::DEBUG_OFF;                      //Turn off debugging
        $this->mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS;            //Enable implicit TLS encryption
        $this->mail->isSMTP();                                            //Send using SMTP
        $this->mail->SMTPAuth = true;                                   //Enable SMTP authentication
        $this->mail->Host = $this->options['host'];                 //Set the SMTP server to send through
        $this->mail->Port = $this->options['port'];                 //TCP port to connect to; use 587 if you have set `SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS`
        $this->mail->Username = $this->options['user'];                 //SMTP username
        $this->mail->Password = $this->options['pass'];                 //SMTP password
    }

    private function addRecipients(): void
    {
        //Recipients
        $this->mail->setFrom($this->options['from']['email'], $this->options['from']['name']);

        //Add a recipient
        foreach ($this->options['recipients'] as $recipient) {
            $email = $recipient['email'];
            $name = !empty($recipient['name']) ? $recipient['name'] : null;
            if ($name == null) {
                $this->mail->addAddress($email);
            } else {
                $this->mail->addAddress($email, $name);
            }
        }
        //Add reply to
        if (isset($this->options['reply-to'])) {
            $email = $this->options['reply-to']['email'];
            $name = !empty($this->options['reply-to']['name']) ? $this->options['reply-to']['name'] : null;
            if ($name == null) {
                $this->mail->addReplyTo($email);
            } else {
                $this->mail->addReplyTo($email, $name);
            }

        }
        //Add cc addresses
        if (isset($this->options['cc'])) {
            foreach ($this->options['cc'] as $cc) {
                $email = $cc['email'];
                $name = !empty($cc['name']) ? $cc['name'] : null;
                if ($name == null) {
                    $this->mail->addCC($email);
                } else {
                    $this->mail->addCC($email, $name);
                }

            }
        }
        //Add bcc addresses
        if (isset($this->options['bcc'])) {
            foreach ($this->options['bcc'] as $bcc) {
                $email = $bcc['email'];
                $name = !empty($bcc['name']) ? $bcc['name'] : null;
                if ($name == null) {
                    $this->mail->addBCC($email);
                } else {
                    $this->mail->addBCC($email, $name);
                }

            }
        }
    }

    private function addAttachments(): void
    {
        try {
            //Add attachments
            if (isset($this->options['attachments'])) {
                foreach ($this->options['attachments'] as $attachment) {
                    $file = $attachment['file'];
                    $name = !empty($attachment['name']) ? $attachment['name'] : null;
                    if ($name == null) {
                        $this->mail->addAttachment($file);
                    } else {
                        $this->mail->addAttachment($file, $name);
                    }
                }
            }
        } catch (Exception $e) {
            error_log($this->mail->ErrorInfo);
        }
    }

    private function addBody(): void
    {
        //Content
        $this->mail->isHTML(true);  //Set email format to HTML
        $this->mail->Subject = $this->options['subject'];
        $this->mail->Body = $this->options['body'];
        //$this->mail->AltBody = $this->options['alt-body'];
    }

    public function send(): void
    {
        try {
            $this->mail->send();
        } catch (\Exception $e) {
            error_log($this->mail->ErrorInfo);
        }
    }
}

