<?php

class Invoice {

    private \Database $db;
    private array $items;
    private array $invoices;
    private int $id = 0;

    public function __construct(\Database $db)
    {
        $this->db = $db;
    }

    public function add(\stdClass $data): int
    {
        $q  = "INSERT INTO `tbproject_invoice` ";
        $q .= "(`project_id`, `sender`, `recipient`, `subtotal`, `tax_rate`, `tax_total`, `discount_rate`, `discount_total`, `total`, `issue_date`, `due_date`, `notes`, `created`) ";
        $q .= "VALUES ";
        $q .= "($data->project_id, $data->sender, $data->recipient, ".($data->subtotal*100).", ".($data->tax_rate*100).", ".($data->tax_total*100).", ".($data->discount_rate*100).", ".($data->discount_total*100).", ".($data->total*100).", ".$this->db->quote($data->issue_date).", ".$this->db->quote($data->due_date).", ".$this->db->quote($data->notes).", UTC_TIMESTAMP());";

        $this->db->setQuery($q)->query();
        return $this->db->lastInsertId();
    }

    public function update(\stdClass $data): void
    {
        $q = "UPDATE `tbproject_invoice` SET `project_id`=$data->project_id, `sender`=$data->sender,`recipient`=$data->recipient, `subtotal`=".($data->subtotal*100).",`tax_rate`=".($data->tax_rate*100).",`tax_total`=".($data->tax_total*100).",`discount_rate`=".($data->discount_rate*100).",`discount_total`=".($data->discount_total*100).",`total`=".($data->total*100).", `issue_date`=".$this->db->quote($data->issue_date).",`due_date`=".$this->db->quote($data->due_date).",`notes`=".$this->db->quote($data->notes)." WHERE invoice_id=$data->invoice_id;";

        $this->db->setQuery($q)->query();
    }

    public function add_items(int $invoice_id, array $data): void
    {
        foreach($data as $item){
            $q  = "INSERT INTO `tbproject_invoice_items`(`invoice_id`, `description`, `unit`, `unit_type`, `rate`, `total`) ";
            $q .= "VALUES ($invoice_id, ".$this->db->quote($item->description).", ".$this->db->quote($item->unit).", ".$this->db->quote($item->unit_type).", ".($item->rate*100).", ".($item->total*100).");";
            $this->db->setQuery($q)->query();
        }
    }

    public function ById(int $id): self {
        $this->id = $id;
        $this->invoices = $this->db->setQuery("SELECT * FROM `tbproject_invoice` WHERE `invoice_id`=$id;")->loadObject();
        return $this;
    }

    public function get(int $id, int $pid, int $sender): self{
        $this->id = $id;
        $this->invoices = $this->db->setQuery("SELECT * FROM `tbproject_invoice` WHERE `invoice_id`=$id AND `sender`=$sender AND `project_id`=$pid;")->loadObject();
        return $this;
    }

    public function billing(int $id, int $pid, int $recipient): self{
        $this->invoices = $this->db->setQuery("SELECT * FROM `tbproject_invoice` WHERE `invoice_id`=$id AND `recipient`=$recipient AND `project_id`=$pid;")->loadObject();
        return $this;
    }

    public function void(int $sender, \stdClass $data): bool {
        $this->db->setQuery("UPDATE `tbproject_invoice` SET `status`=5, `void_date`=UTC_TIMESTAMP() WHERE `invoice_id`=$data->invoice_id AND `project_id`=$data->project_id AND `sender`=$sender AND `recipient`=(SELECT `user_id` FROM `tbproject` WHERE `project_id`=$data->project_id);")->query();
        return $this->db->getErrorCode() == '0';
    }

    public function paid(int $sender, \stdClass $data): bool {
        $this->db->setQuery("UPDATE `tbproject_invoice` SET `status`=3, `paid_date`=UTC_TIMESTAMP() WHERE `invoice_id`=$data->invoice_id AND `project_id`=$data->project_id AND `sender`=$sender AND `recipient`=(SELECT `user_id` FROM `tbproject` WHERE `project_id`=$data->project_id);")->query();
        return $this->db->getErrorCode() == '0';
    }

    public function send(int $sender, \stdClass $data): bool {
        $this->db->setQuery("UPDATE `tbproject_invoice` SET `status`=2, `sent_date`=UTC_TIMESTAMP() WHERE `invoice_id`=$data->invoice_id AND `project_id`=$data->project_id AND `sender`=$sender AND `recipient`=(SELECT `user_id` FROM `tbproject` WHERE `project_id`=$data->project_id);")->query();
        return $this->db->getErrorCode() == '0';
    }

    public function items(int $id = 0): self {
        $id = $this->id > 0 ? $this->id : $id;
        $this->items = $this->db->setQuery("SELECT * FROM `tbproject_invoice_items` WHERE `invoice_id`=$id;")->loadObject();
        return $this;
    }

    public function deleteItems(int $id): void
    {
        $this->db->setQuery("DELETE FROM `tbproject_invoice_items` WHERE `invoice_id`=$id;")->query();
    }

    public function getInvoices(): array
    {
        return $this->invoices;
    }

    public function getItems(): array
    {
        return $this->items;
    }
}