<?php


use \CuteHttp\Client;
use \CuteLogger\Logger;

class PayPalCheckout {

    private string $base_uri = "https://api-3t.sandbox.paypal.com";
    private static self $instance;
    private static Client $client;
    private string $user = "sb-f9om022042242_api1.business.example.com";
    private string $pwd = "URZ26BKT2NMJL73R";
    private string $signature = "Aa6c7S226xRLkxxBxJVwhoijLY.qAXpVptabo.APhrHGojZyuosykY4L";
    private int $api_version = 204;
    public static array $CONFIG;


    public static function getInstance(): self{
        if(!isset(self::$instance)){
            self::$instance = new self();
        }
        return self::$instance;
    }

    private function __construct()
    {
    }

    public function InitiateBillingAgreement(): string
    {
        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $desc = urlencode("for future payments");

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&L_BILLINGTYPE0=MerchantInitiatedBillingSingleAgreement&PAYMENTREQUEST_0_CURRENCYCODE=USD&L_BILLINGAGREEMENTDESCRIPTION0=$desc";
        $data .= "&METHOD=SetExpressCheckout&PAYMENTREQUEST_0_AMT=0&RETURNURL=".self::$CONFIG['RETURN_URL'];
        $data .= "&CANCELURL=".self::$CONFIG['RETURN_URL'];

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }


    public function CreateBillingAgreement(string $token): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=CreateBillingAgreement&TOKEN=$token";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }

    public function GetBalance(): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=GetBalance";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }

    public function DoReferenceTransaction(string $billing_id, float $amount): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $billing_id = urlencode($billing_id);

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=DoReferenceTransaction&REFERENCEID=$billing_id&PAYMENTACTION=Sale&AMT=$amount";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }

    public function DoNonReferencedCredit(float $amount, string $currency = "USD"): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=DoNonReferencedCredit&AMT=$amount&CURRENCYCODE=$currency";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }

    public function CancelBillingAgreement(string $ReferenceID): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $ReferenceID = urlencode($ReferenceID);

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=BillAgreementUpdate&REFERENCEID=$ReferenceID&BILLINGAGREEMENTSTATUS=Canceled";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }

    public function InitiateRecurringPayments(): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $desc = urlencode('for recurring payments');

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&L_BILLINGTYPE0=RecurringPayments&L_BILLINGAGREEMENTDESCRIPTION0=$desc";
        $data .= "&METHOD=SetExpressCheckout&RETURNURL=https://www.ioimg.net/user/?option=payments";
        $data .= "&CANCELURL=https://www.ioimg.net/user/?option=payments";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }

    public function CreateRecurringPaymentsProfile(string $token, string $billingPeriod, float $amount): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $desc = urlencode('for recurring payments');

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=CreateRecurringPaymentsProfile&PROFILESTARTDATE=".date('Y-m-d\TH:i:s\Z')."&DESC=$desc";
        $data .= "&BILLINGPERIOD=Month&BILLINGFREQUENCY=1&AMT=$amount&CURRENCYCODE=USD&TOKEN=$token";
        $data .= "&MAXFAILEDPAYMENTS=1&INITAMT=$amount&AUTOBILLOUTAMT=AddToNextBilling";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }


    public function GetRecurringPaymentsProfileDetails(string $profileid): string{

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $profileid = urlencode($profileid);

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=GetRecurringPaymentsProfileDetails&PROFILEID=$profileid";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }


    /**
     * @param string $profileid
     * @param string $action //Cancel, Suspend, Reactivate
     * @param string $note
     * @return string
     */
    public function ManageRecurringPaymentsProfileStatus(string $profileid, string $action, string $note): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $desc = urlencode('for recurring payments');
        $profileid = urlencode($profileid);
        $note = urlencode($note);

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=ManageRecurringPaymentsProfileStatus&PROFILEID=$profileid&ACTION=$action&NOTE=$note";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }



    public function GetExpressCheckoutDetails(string $token): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=GetExpressCheckoutDetails&TOKEN=$token";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }


    public function DoExpressCheckoutPayment(string $GetExpressCheckoutDetailsResponse): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=DoExpressCheckoutPayment&$GetExpressCheckoutDetailsResponse";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }


    public function RefundTransaction(string $transaction_id, ?float $amount, string $refund_type = "Full"): string {

        self::$client = new Client(['base_uri' => $this->base_uri, 'Content-Type' => 'application/x-www-form-urlencoded']);

        $data = "USER=".$this->user."&PWD=".$this->pwd."&SIGNATURE=".$this->signature."&VERSION=".$this->api_version;
        $data .= "&METHOD=RefundTransaction&TRANSACTIONID=$transaction_id&REFUNDTYPE=$refund_type";
        $data .= strtolower($refund_type) === 'partial' && $amount ? "&AMT=$amount" : "";

        $options = [
            'verify' => false,
            'body' => $data
        ];

        $response = self::$client->request('post', '/nvp', $options);

        Logger::Debug(json_encode($response));

        return $response;
    }

}