<?php


class SessionManager {

    private static string $session_name = "SESSION_MANAGER";

    private function __construct() {

    }

    public static function set(string $name, mixed $value): void {
        $_SESSION[$name] = $value;
    }

    public static function add_to_list(string $name, mixed $value): void {
        $_SESSION[$name] = self::get_list($name);
        $_SESSION[$name][] = $value;
    }

    public static function get_list(string $name): array {
        return $_SESSION[$name] ?? array();
    }

    public static function get(string $name){
        return $_SESSION[$name] ?? null;
    }

    public static function destroy(){
        session_unset();
        session_destroy();
        session_write_close();
    }

    private function __clone(): void { }


}