<?php


class Transaction {

    private Database $db;

    public function __construct(Database $db)
    {
        $this->db = $db;
    }

    public function initialize($processor, $uid, $data): string
    {
        $tranid = $this->db->setQuery("CALL spTransactionId();")->loadResult()->tranid;
        $rtid = "$uid-$tranid";

        $uid = $this->db->quote($uid);
        $pid = $this->db->quote(strtoupper($data->method));
        $ccid = $this->db->quote($data->ccid);
        $amount = $this->db->quote($data->amount);

        $this->db->setQuery("CALL spTransactionInit($tranid, $uid, '$rtid', $amount, 'USD', 'CREATED', $pid, $ccid);")->query();

        $array = $processor->initialize($rtid, $data->amount);

        return $array[1];
    }
    
    public function credit_card($processor, $cc, $data): string {

        $tranid = $this->db->setQuery("CALL spTransactionId();")->loadResult()->tranid;
        $rtid = "{$cc->user_id}-$tranid";

        $uid = $this->db->quote($cc->user_id);
        $pid = $this->db->quote(strtoupper($data->method));
        $ccid = $this->db->quote($data->ccid);
        $amount = $this->db->quote($data->amount);

        $this->db->setQuery("CALL spTransactionInit($tranid, $uid, '$rtid', $amount, 'USD', 'CREATED', $pid, $ccid);")->query();

        $array = $processor->credit_card($rtid, $cc, $data->amount);

        return $array[1];
    }
    

}