<?php
namespace NextGen\Classes;

define('UPS_XAV_WSDL', __DIR__ . "/wsdl/XAV.wsdl");

class UPSClient {
    const ACCESS = "2CD850E77D3722E5";
    const USERID = "agillapro";
    const PASSWD = "Blooms20169";
    const WSDL = UPS_XAV_WSDL;
    const OPERATION = "ProcessXAV";
    const ENDPOINTURL = 'https://onlinetools.ups.com/webservices/XAV';

    private static function createRequest($address, $city, $state, $postal_code, $country_code, $company) {
        $option['RequestOption'] = '3';
        $request['Request'] = $option;

//    $addrkeyfrmt['ConsigneeName'] = "{$company}";
        $addrkeyfrmt['AddressLine'] = $address;
        $addrkeyfrmt['PostcodePrimaryLow'] = $postal_code;
        $addrkeyfrmt['PoliticalDivision2'] = $city;
        $addrkeyfrmt['PoliticalDivision1'] = $state;
        $addrkeyfrmt['CountryCode'] = $country_code;
        $request['AddressKeyFormat'] = $addrkeyfrmt;

        return $request;
    }

    public static function validateAddress($address, $city, $state, $postal_code, $country_code, $company) {
        $final_address = array();
        foreach ($address as &$v) {
            $v = strtoupper($v);
            if (!empty($v)) {
                $final_address[] = $v;
            }
        }

        $address = $final_address;

        $city         = strtoupper($city);
        $state        = strtoupper($state);
        $postal_code  = strtoupper($postal_code);
        $country_code = strtoupper($country_code);
        $company      = strtoupper($company);

        try {
            $mode = array
            (
                'soap_version' => 'SOAP_1_1',  // use soap 1.1 client
                'trace' => 1
            );

            $client = new \SoapClient(self::WSDL, $mode);
            $client->__setLocation(self::ENDPOINTURL);

            $usernameToken['Username'] = self::USERID;
            $usernameToken['Password'] = self::PASSWD;
            $serviceAccessLicense['AccessLicenseNumber'] = self::ACCESS;
            $upss['UsernameToken'] = $usernameToken;
            $upss['ServiceAccessToken'] = $serviceAccessLicense;

            $header = new \SoapHeader('http://www.ups.com/XMLSchema/XOLTWS/UPSS/v1.0','UPSSecurity',$upss);
            $client->__setSoapHeaders($header);

            $resp = $client->__soapCall(self::OPERATION ,array(self::createRequest($address, $city, $state, $postal_code, $country_code, $company)));

            error_log(json_encode($resp));

            if (isset($resp->Response)) {
                if($resp->Response->ResponseStatus->Code == 1 && isset($resp->Candidate)) {
                    $candidate = is_array($resp->Candidate) ? $resp->Candidate[0] : $resp->Candidate;
                    return $candidate;
                }
            }
        } catch(\Exception $ex) {
            return null;
        }

        return null;
    }
}
