<?php

function prefix($array, $prefix): array
{
    $arr = array();
    foreach ($array as $v){
        $arr[] = $prefix . $v;
    }
    return $arr;
}

function __substr($string, $needle, $inclusive = true): string
{
    $pos = strpos($string, $needle);
    $pos = $inclusive ? $pos + strlen($needle) : 0;
    return substr($string, 0, $pos);
}

function getProductImage($pid){
    global $config;
    $uri = "{$config->product_image_url}{$pid}.webp";
    //return $uri;
    /*$task = new class extends \Thread {
      public $response;
      public function run()
      {
         $this->response = @file_get_contents($uri) !== false ? $uri : $config->default_product_image_url;
      }
    };
    $task->start() && $task->join();
    return $task->response;*/
    return @file_get_contents($uri) !== false ? $uri : $config->default_product_image_url;
    //$headers = @get_headers($uri);
    //return str_contains($headers[0], '200') ? $uri : $config->default_product_image_url;
}

function redirect($url)
{
    if (!headers_sent()) {
        header("Location: $url");
    } else {
        echo "<meta http-equiv='refresh' content='0;url=$url' />";
    }
    exit;
}

function urlBuild($q)
{
    $url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]";
    //$url = urlRemoveQueryString($url, $q);
    return $url;
}

function urlHasQueryString($url)
{
    return parse_url($url, PHP_URL_QUERY);
}

function urlRemoveQueryString($url, $key) {
    return preg_replace('/(?:&|(\?))'.$key.'=[^&]*(?(1)&|)?/i', "", $url);
}

function replace_links($text)
{
    //replace textual URLs with HTML links, this also works for email addresses.
    $text = preg_replace('#(script|about|applet|activex|chrome):#is', "\\1:", $text);
    $ret = ' ' . $text;
    // Replace Links with http://
    $ret = preg_replace("#(^|[\n ])([\w]+?://[\w\#$%&~/.\-;:=,?@\[\]+]*)#is", "\\1<a href=\"\\2\" target=\"_blank\" rel=\"nofollow\">\\2</a>", $ret);
    // Replace Links without http://
    $ret = preg_replace("#(^|[\n ])((www|ftp)\.[\w\#$%&~/.\-;:=,?@\[\]+]*)#is", "\\1<a href=\"http://\\2\" target=\"_blank\" rel=\"nofollow\">\\2</a>", $ret);
    // Replace Email Addresses
    $ret = preg_replace("#(^|[\n ])([a-z0-9&\-_.]+?)@([\w\-]+\.([\w\-\.]+\.)*[\w]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $ret);
    $ret = substr($ret, 1);
    return $ret;
}