<?php
require_once __DIR__ . '/config.php';

$areas = ['BASKING RIDGE','BEDMINSTER','BERNARDSVILLE','BOUND BROOK','BRANCHBURG','BRIDGEWATER','CLINTON','DUNELLEN','EDISON','FRANKLIN PARK','GREEN BROOK','HIGHLAND PARK','HILLSBOROUGH','MANVILLE','MARTINSVILLE','METUCHEN','MIDDLESEX','MILLINGTON','NEW BRUNSWICK','NORTH BRUNSWICK','NORTH PLAINFIELD','PLAINFIELD','PISCATAWAY','RARITAN','SOMERSET','SOMERVILLE','SOUTH BOUND BROOK','SOUTH PLAINFIELD','WARREN'];
$services = ['BABYSITTING','ALZHEIMER\'S & DEMENTIA CARE','PARKINSON\'S CARE','COMPANION CARE','PERSONAL CARE','TRANSITIONAL CARE','CHRONIC DISEASE CARE','VA BENEFIT ASSISTANCE','RESPITE CARE','SURGERY ASSISTANCE','END-OF-LIFE SUPPORT CARE','ROUND-THE-CLOCK & LIVE IN CARE'];
?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1">
    <title>Heart & Soul Caregiver</title>
    <meta name="title" content="Heart & Soul Caregiver">
    <meta name="description" content="Heart & Soul Caregiver" />
    <meta name="keywords" content="caregiver, old care, health care, old age care, nursing, senior care, retire care" />
    <meta name="Author" content="heart & soul caregiver (www.heartandsoulcaregiverllc.com)" />

    <!--<link rel="apple-touch-icon" sizes="57x57" href="favicon/apple-icon-57x57.png">
    <link rel="apple-touch-icon" sizes="60x60" href="favicon/apple-icon-60x60.png">
    <link rel="apple-touch-icon" sizes="72x72" href="favicon/apple-icon-72x72.png">
    <link rel="apple-touch-icon" sizes="76x76" href="favicon/apple-icon-76x76.png">
    <link rel="apple-touch-icon" sizes="114x114" href="favicon/apple-icon-114x114.png">
    <link rel="apple-touch-icon" sizes="120x120" href="favicon/apple-icon-120x120.png">
    <link rel="apple-touch-icon" sizes="144x144" href="favicon/apple-icon-144x144.png">
    <link rel="apple-touch-icon" sizes="152x152" href="favicon/apple-icon-152x152.png">
    <link rel="apple-touch-icon" sizes="180x180" href="favicon/apple-icon-180x180.png">
    <link rel="icon" type="image/png" sizes="192x192"  href="favicon/android-icon-192x192.png">
    <link rel="icon" type="image/png" sizes="32x32" href="favicon/favicon-32x32.png">
    <link rel="icon" type="image/png" sizes="96x96" href="favicon/favicon-96x96.png">
    <link rel="icon" type="image/png" sizes="16x16" href="favicon/favicon-16x16.png">
    <link rel="manifest" href="favicon/manifest.json">
    <meta name="msapplication-TileColor" content="#ffffff">
    <meta name="msapplication-TileImage" content="favicon/ms-icon-144x144.png">
    <meta name="theme-color" content="#ffffff">-->
    <link href="https://fonts.googleapis.com/css?family=Poppins:100,300,400,700,900" rel="stylesheet">
    <link rel="stylesheet" href="<?=$config->site?>/assets/fontawesome/css/all.css?h=<?=$hash?>">
    <link rel="stylesheet" href="<?=$config->site?>/assets/css/style.css?h=<?=$hash?>">
    <link rel="stylesheet" href="<?=$config->site?>/assets/bootstrap/css/bootstrap.min.css?h=<?=$hash?>">
    <script type="text/javascript" src="<?=$config->site?>/assets/bootstrap/js/bootstrap.min.js?h=<?=$hash?>"></script>
</head>

<body>

<div class="container mb-5">
    <div class="row mt-5 mb-5">
        <div class="col-12">
            <div class="d-flex align-items-center">
                <div class="me-2"><img style="width:90px;" src="<?=$config->site?>/assets/images/logo-2.png" /></div>
                <div class="fw-bold">Heart & Soul Caregiver LLC</div>
            </div>
        </div>
    </div>
    <div class="row mb-5">
        <div class="col-12">
            <div class="row">
                <div class="col-ms-6 col-md-6 mb-3 d-flex align-items-center text-center justify-content-center float-end">
                    <div>
                        <p class="text-orange">WELCOME TO HEART AND SOUL CAREGIVER LLC</p>
                        <p class="fw-bold h3">WE PROVIDE CUSTOMIZED IN-HOME CARE AND NURSING SERVICES.</p>
                    </div>
                </div>
                <div class="col-sm-6 col-md-6">
                    <div class="float-start">
                        <img class="img-thumbnail rounded-5 mb-2" style="width:380px;" src="<?=$config->site?>/assets/images/main-1.png" />
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row mb-5">
        <div class="col-12">
            <div class="row">
                <div class="col-ms-6 col-md-6 mb-3 d-flex align-items-center text-center justify-content-center float-end">
                    <div>
                        <p class="fw-bold h3">HEARTFUL HEALING: A WORLD OF COMPASSIONATE NURSING CARE AWAITS YOU</p>
                    </div>
                </div>
                <div class="col-sm-6 col-md-6">
                    <div class="float-start">
                        <img class="img-thumbnail rounded-5 mb-2" style="width:380px;" src="<?=$config->site?>/assets/images/main-2.png" />
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row mb-5">
        <div class="col-12">
            <div class="row">
                <div class="col-ms-6 col-md-6 mb-3 d-flex align-items-center text-center justify-content-center float-end">
                    <div>
                        <p class="fw-bold h3">MAKING A POSITIVE IMPACT IN LIVES THROUGH EXCEPTIONAL NURSING</p>
                    </div>
                </div>
                <div class="col-sm-6 col-md-6">
                    <div class="float-start">
                        <img class="img-thumbnail rounded-5 mb-2" style="width:380px;" src="<?=$config->site?>/assets/images/main-3.png" />
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row mb-5">
        <div class="col-12">
            <div class="row">
                <div class="col-ms-6 col-md-6 mb-3 d-flex align-items-center text-center justify-content-center float-end">
                    <div>
                        <p class="fw-bold h3">ENSURING THE WELL-BEING AND COMFORT OF YOUR LOVED ONES</p>
                    </div>
                </div>
                <div class="col-sm-6 col-md-6">
                    <div class="float-start">
                        <img class="img-thumbnail rounded-5 mb-2" style="width:380px;" src="<?=$config->site?>/assets/images/main-4.png" />
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row mb-5">
        <div class="col-12">
            <div class="text-center">
                <div class="">
                    <div class="fw-bold h3">AREAS WE SERVE</div>
                </div>
               <div class="d-flex flex-wrap rounded-5 p-3" style="border:1px solid #ff8000;">
                   <?php
                   $i = 0;
                   $len = count($areas) -1;
                   foreach($areas as $area){
                       echo $area;
                       if($i < $len){
                           echo '<span class="ms-2 me-2">&bull;</span>';
                       }
                       $i++;
                   }
                   ?>
               </div>
            </div>
        </div>
    </div>
    <div class="row mb-5">
        <div class="col-12">
            <div class="text-center">
                <div class="d-flex justify-content-center flex-column">
                    <div class="text-orange">OUR SERVICE</div>
                    <div class="fw-bold h3">SERVICES WE OFFER</div>
                </div>
                <div class="services">
                    <?php
                    foreach($services as $service){
                        echo "<div class='item'>";
                        echo "<i class='fa-solid fa-list-ul me-3'></i>";
                        echo $service;
                        echo "</div>";
                    }
                    ?>
                </div>
            </div>
        </div>
    </div>
    <div class="row mb-5">
        <div class="col-12">
            <div class="bg-orange rounded-4 p-4">
                <div class="d-flex align-items-center justify-content-between flex-wrap text-center">
                    <div class="fw-bold h4 float-start">LOOKING FOR ELDERLY CARE OR A BABYSITTER? GIVE US A CALL</div>
                    <div class=" text-center">
                        <div class="phone fw-semibold"><i class="fa-solid fa-phone me-2" style="color:#fff;"></i>+1 (201) 675-7904</div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="row mb-5">
        <div class="col-12">
            <div class="h3 fw-bold mb-3">CONTACT US</div>
            <div class="d-flex align-items-center mb-4"><i class="fa-light fa-phone-volume fa-xl me-2" style="color:#ff8000"></i><div>+1 (201) 675-7904</div></div>
            <div class="d-flex align-items-center mb-4"><i class="fa-light fa-fax fa-xl me-2" style="color:#ff8000"></i><div>+1 (732) 200-5916</div></div>
            <div class="d-flex align-items-center mb-4"><i class="fa-light fa-envelope fa-xl me-2" style="color:#ff8000"></i><div>heartandsoulcaregiver@yahoo.com</div></div>
            <div class="d-flex align-items-center mb-4"><i class="fa-light fa-location-dot fa-xl me-2" style="color:#ff8000"></i><div>588 MOUNTAIN VIEW TERRACE MIDDLESEX, NJ 08846-1653</div></div>
        </div>
    </div>
</div>
</body>

</html>